﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Diagnostics;
using SlimDX.Direct3D9;
using FDK;

namespace StrokeStyleT
{
	class CAct英数字描画 : CActivity
	{
		public enum E種別 {
			白 = 0, 黄 = 1, 灰 = 2,
			白太 = 0, 黄太 = 1, 灰太 = 2 
		};

		public void t表示( Device D3D9Device, int x, int y, E種別 e種別, string str英数字文字列 )
		{
			this.act英数字描画.t表示( D3D9Device, this.txFont[ (int) e種別 ], x, y, str英数字文字列 );
		}

		public CAct英数字描画()
		{
			// rc文字の矩形領域[] の初期化。

			this.rc文字の矩形領域 = new Rectangle[ 96 ];
			for( int i = 0; i < 96; i++ )
			{
				this.rc文字の矩形領域[ i ].X = ( i % 16 ) * 8;
				this.rc文字の矩形領域[ i ].Y = ( i / 16 ) * 16;
				this.rc文字の矩形領域[ i ].Width = 8;
				this.rc文字の矩形領域[ i ].Height = 16;
			}

			// 子Activityの登録。

			this.list子Activities.Add( this.act英数字描画 = new CMAct文字列描画( " !\"#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\\]^_`abcdefghijklmnopqrstuvwxyz{|}~ ", 8 ) );
		}
		public override void OnManagedリソースの作成( Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			// テクスチャを生成。

			this.txFont = new CTexture[ 3 ];
			this.txFont[ (int) E種別.白 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font 8x16 white.png" ) );
			this.txFont[ (int) E種別.黄 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font 8x16 yellow.png" ) );
			this.txFont[ (int) E種別.灰 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font 8x16 gray.png" ) );
			this.txFontBold = new CTexture[ 3 ];
			this.txFontBold[ (int) E種別.白太 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font bold 8x16 white.png" ) );
			this.txFontBold[ (int) E種別.黄太 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font bold 8x16 yellow.png" ) );
			this.txFontBold[ (int) E種別.灰太 ] = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Console font bold 8x16 gray.png" ) );

			// テクスチャの描画範囲リストを作成。

			for( int i = 0; i < 96; i++ )
			{
				this.txFont[ (int) E種別.白 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
				this.txFont[ (int) E種別.黄 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
				this.txFont[ (int) E種別.灰 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
				this.txFontBold[ (int) E種別.白太 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
				this.txFontBold[ (int) E種別.黄太 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
				this.txFontBold[ (int) E種別.灰太 ].list描画範囲.Add( this.rc文字の矩形領域[ i ] );
			}

			base.OnManagedリソースの作成( D3D9Device );
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.txFont[ (int) E種別.白 ] );
			C共通.tDisposeする( ref this.txFont[ (int) E種別.黄 ] );
			C共通.tDisposeする( ref this.txFont[ (int) E種別.灰 ] );
			C共通.tDisposeする( ref this.txFontBold[ (int) E種別.白太 ] );
			C共通.tDisposeする( ref this.txFontBold[ (int) E種別.黄太 ] );
			C共通.tDisposeする( ref this.txFontBold[ (int) E種別.灰太 ] );

			base.OnManagedリソースの解放();
		}

		#region [ protected ]
		//-----------------
		protected CMAct文字列描画 act英数字描画 = null;
		protected CTexture[] txFont = null;					// [E種別]
		protected CTexture[] txFontBold = null;				// [E種別]
		protected Rectangle[] rc文字の矩形領域 = null;		// [96]
		//-----------------
		#endregion
	}
}
