﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Diagnostics;
using System.Xml.Serialization;
using System.Windows.Forms;
using FDK;

namespace StrokeStyleT
{
	public class EnvironmentParameters
	{
		// プロパティ（保存される）

		/// <summary>
		/// <para>曲毎に固有の属性。</para>
		/// <para>\&lt;SSTFファイルのフルパス（マクロあり）, 属性インスタンス&gt;</para>
		/// </summary>
		public CSerializableDictionary<string, C曲固有属性> dic曲固有属性 = new CSerializableDictionary<string, C曲固有属性>();
		public class C曲固有属性
		{
			public long n遅延差分ms = 0;
		}


		// メソッド（保存されない）

		internal static EnvironmentParameters t読み込む( string fileName )
		{
			EnvironmentParameters EnvProperties = null;

			#region [ XMLファイルを読み込む。]
			//-----------------
			try
			{
				C共通.tXMLファイルを読み込む( fileName, out EnvProperties );
			}
			catch( FileNotFoundException )
			{
				Trace.TraceInformation( "ファイルが存在しません。規定値を使用します。[{0}]", Global.Folder.tファイルパスをマクロ付きパスに逆展開する( fileName ) );
				EnvProperties = new EnvironmentParameters();
			}
			catch( Exception e )
			{
				C共通.t例外の詳細をログに出力する( e );
				Trace.TraceInformation( "ファイルの読み込みに失敗しました。規定値を使用します。[{0}]", Global.Folder.tファイルパスをマクロ付きパスに逆展開する( fileName ) );
				EnvProperties = new EnvironmentParameters();
			}
			//-----------------
			#endregion

			#region [ ファイルパスのマクロを展開する。]
			//-----------------
			var dicSongStatusマクロ付き = new CSerializableDictionary<string, C曲固有属性>();

			foreach( var kvp in EnvProperties.dic曲固有属性 )
				dicSongStatusマクロ付き.Add( Global.Folder.tファイルパスのマクロを展開する( kvp.Key ), kvp.Value );

			EnvProperties.dic曲固有属性.Clear();
			EnvProperties.dic曲固有属性 = dicSongStatusマクロ付き;
			//-----------------
			#endregion

			return EnvProperties;
		}
		internal void t保存する( string fileName )
		{
			#region [ ファイルパスをマクロに逆展開する。]
			//----------------- 	 
			var dicSongStatus生パス = new CSerializableDictionary<string, C曲固有属性>();

			foreach( var kvp in this.dic曲固有属性 )
				dicSongStatus生パス.Add( Global.Folder.tファイルパスをマクロ付きパスに逆展開する( kvp.Key ), kvp.Value );
			//----------------- 	 
			#endregion

			var backup = this.dic曲固有属性;   // ファイルパスのマクロを展開するのが面倒なのでバックアップしておく。 	 
			this.dic曲固有属性 = dicSongStatus生パス;

			#region [ XMLファイルを保存する。]
			//-----------------
			try
			{
				C共通.tXMLファイルを保存する( fileName, this );
			}
			catch( Exception e )
			{
				MessageBox.Show( "ファイルの保存に失敗しました。[{0}]\n--------\n" + e.ToString(),
					Global.Folder.tファイルパスをマクロ付きパスに逆展開する( fileName ) );
			}
			//-----------------
			#endregion

			this.dic曲固有属性 = backup;       // ファイルパスのマクロを展開したものに戻す。
		}
	}
}
