﻿using System;
using System.Collections.Generic;
using System.Runtime.InteropServices;
using System.Diagnostics;
using SlimDX;
using SlimDX.Direct3D9;
using FDK;

namespace StrokeStyleT
{
	/// <summary>
	/// <para>チップがヒットしたときの火花。</para>
	/// </summary>
	class CAct演奏チップファイア : CActivity
	{
		public void t発火( E演奏レーン eレーン, int nY座標補正値 )
		{
			this.t発火( eレーン, nY座標補正値, false, false );
		}
		public void t発火( E演奏レーン eレーン, int nY座標補正値, bool bフィルイン )
		{
			this.t発火( eレーン, nY座標補正値, bフィルイン, false );
		}
		public void t発火( E演奏レーン eレーン, int nY座標補正値, bool bフィルイン, bool b大波 )
		{
			if( eレーン == E演奏レーン.Unknown )
				return;

			#region [ 火花の生成 ]
			//-----------------
			this.mAct火花.t2D発火(
				Global.Theme.m演奏ステージ.dicパッドの中心スクリーン座標px[ eレーン ].X,
				Global.Theme.LogicalDisplaySize.Height - Global.Theme.m演奏ステージ.DistanceFromHitBarToScreenBottom + nY座標補正値 );
			//-----------------
			#endregion
			#region [ 拡散波の生成 ]
			//-----------------
			int n中心Xpt = Global.Theme.m演奏ステージ.dicパッドの中心スクリーン座標px[ eレーン ].X;
			int n中心Ypt = Global.Theme.LogicalDisplaySize.Height - Global.Theme.m演奏ステージ.DistanceFromHitBarToScreenBottom + nY座標補正値;
			this.mAct拡大波.t3D発火( 
				CTexture.t論理画面座標をワールド座標へ変換する( n中心Xpt, n中心Ypt ),	// 中心位置
				new Vector3( 0f, 0f, 1f ),	// 拡散波の法線
				0.1f, 1.5f,					// 最小倍率、最大倍率
				200,						// 所要時間[ms]
				0.21f );					// 最大不透明度(透明]:0～1:不透明)
			//-----------------
			#endregion
			#region [ 拡散粒子の生成 ]
			//-----------------
			this.mAct拡散粒子.t2D発火(
				Global.Theme.m演奏ステージ.dicパッドの中心スクリーン座標px[ eレーン ].X,
				Global.Theme.LogicalDisplaySize.Height - Global.Theme.m演奏ステージ.DistanceFromHitBarToScreenBottom + nY座標補正値 );
			//-----------------
			#endregion

			if( bフィルイン )
			{
			}
			if( b大波 )
			{
			}
		}

		public CAct演奏チップファイア()
		{
			this.list子Activities.Add( this.mAct火花 = new CMAct点フラッシュ・回転羽( 32 ) );
			this.list子Activities.Add( this.mAct拡散粒子 = new CMAct点フラッシュ・拡散粒子( 32, 8 ) );
			this.list子Activities.Add( this.mAct拡大波 = new CMAct点フラッシュ・拡大波( 32 ) );
		}

		public override void OnManagedリソースの作成( Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			this.tx羽 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenPlay chip fire.png" ) );
			if( this.tx羽 != null )
				this.tx羽.b加算合成 = true;

			this.tx拡散粒子 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenPlay chip star.png" ) );
			if( this.tx拡散粒子 != null )
				this.tx拡散粒子.b加算合成 = true;

			this.tx拡大波 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenPlay chip wave2.png" ) );
			if( this.tx拡大波 != null )
				this.tx拡大波.b加算合成 = true;

			base.OnManagedリソースの作成( D3D9Device );
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.tx羽 );
			C共通.tDisposeする( ref this.tx拡散粒子 );
			C共通.tDisposeする( ref this.tx拡大波 );

			base.OnManagedリソースの解放();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return 0;

			this.mAct火花.On進行();
			this.mAct拡散粒子.On進行();
			this.mAct拡大波.On進行();

			return 0;
		}
		public override void On描画( Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			this.mAct火花.On描画( D3D9Device, this.tx羽 );
			this.mAct拡散粒子.On描画( D3D9Device, this.tx拡散粒子 );
			this.mAct拡大波.On描画( D3D9Device, this.tx拡大波 );
		}

		#region [ protected ]
		//-----------------
		protected CTexture tx羽 = null;
		protected CTexture tx拡散粒子 = null;
		protected CTexture tx拡大波 = null;
		protected CMAct点フラッシュ・回転羽 mAct火花 = null;
		protected CMAct点フラッシュ・拡散粒子 mAct拡散粒子 = null;
		protected CMAct点フラッシュ・拡大波 mAct拡大波 = null;
		//-----------------
		#endregion
	}
}
