﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using SlimDX;
using SlimDX.DirectInput;
using FDK;

namespace StrokeStyleT
{
	class C結果ステージ : CStageBase
	{
		public C結果ステージ()
		{
			this.list子Activities.Add( this.Actホワイトイン = new CMActフェードイン・透明度( 1 ) );
			this.list子Activities.Add( this.Actブラックアウト = new CMActフェードアウト・透明度( 1 ) );
			this.list子Activities.Add( this.Act結果パラメータ文字列描画 = new CMAct文字列描画( @"0123456789(.)%*", 47, 30 ) );

			this.eStageID = EステージID.結果;
			this.ePhaseID = EフェーズID.フェードイン;
		}

		public override void On活性化( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			this.ds背景動画 = Global.t失敗してもスキップ可能なDirectShowを生成する( Global.Theme.tファイルパス( @"ScreenResult BGV.mp4" ), Global.App.hWnd, true );
			this.ePhaseID = EフェーズID.フェードイン;

			base.On活性化( D3D9Device );
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( this.ds背景動画 ); this.ds背景動画 = null;
			
			base.On非活性化();
		}
		public override void OnManagedリソースの作成( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			this.txWhite = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"White 64x64.png" ) );
			this.txBlack = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"Black 64x64.png" ) );
			this.tx背景 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenResult background.png" ) );
			this.tx結果表示パラメータパネル = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenResult parameter panel.png" ) );
			this.tx結果パラメータフォント = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenResult parameter font.png" ) );

			for( int i = 0; i < 15; i++ )
				this.tx結果パラメータフォント.list描画範囲.Add( new Rectangle( ( i % 5 ) * 30, ( i / 5 ) * 58, 30, 58 ) );

			#region [ 活性化時に背景動画が生成されている場合は背景動画用テクスチャを作成する。]
			//-----------------
			if( this.ds背景動画 != null )
			{
				this.tx背景動画 = Global.tテクスチャを生成する( this.ds背景動画.n幅px, this.ds背景動画.n高さpx );

				if( this.tx背景動画 != null )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
			}
			else
				this.tx背景動画 = null;
			//-----------------
			#endregion

			base.OnManagedリソースの作成( D3D9Device );
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( ref this.txWhite );
			C共通.tDisposeする( ref this.txBlack );
			C共通.tDisposeする( ref this.tx背景 );
			C共通.tDisposeする( ref this.tx結果表示パラメータパネル );
			C共通.tDisposeする( ref this.tx結果パラメータフォント );
			C共通.tDisposeする( ref this.tx背景動画 );

			base.OnManagedリソースの解放();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return (int) CApp.E状態処理結果.ステージ継続;

			// 進行。

			#region [ 初めての進行処理。]
			//-----------------
			if( this.b初めての進行 )
			{
				if( this.ds背景動画 != null )
				{
					this.ds背景動画.bループ再生 = true;
					this.ds背景動画.t再生開始();
				}

				this.Actホワイトイン.t開始();
				this.b初めての進行 = false;
			}
			//-----------------
			#endregion

			#region [ フェードイン → 完了したら通常フェーズへ ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードイン )
			{
				if( this.Actホワイトイン.b完了 )
					this.ePhaseID = EフェーズID.通常;

				this.Actホワイトイン.On進行();	// 進行は完了チェックの後に！
			}
			//-----------------
			#endregion
			#region [ フェードアウト → 完了したらステージ終了 ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードアウト )
			{
				if(this.Actブラックアウト.b完了)
					return (int) CApp.E状態処理結果.OK;

				this.Actブラックアウト.On進行();	// 進行は完了チェックの後に！
			}
			//-----------------
			#endregion


			// 入力。

			#region [ ESC or シンバル類 → ブラックアウトフェーズへ ]
			//-----------------
			if( Global.Input.Input管理.Keyboard.bキーが押された( Key.Escape ) ||
				Global.Input.bシンバル類のいずれかが押された )
			{
				if( this.ePhaseID != EフェーズID.フェードアウト )
				{
					this.Actブラックアウト.t開始();
					this.ePhaseID = EフェーズID.フェードアウト;
				}
			}
			//-----------------
			#endregion
			#region [ WM_CLOSE → 終了 ]
			//-----------------
			if( Global.App.bWM_CLOSEを受け取った )
			{
				return (int) CApp.E状態処理結果.終了;
			}
			//-----------------
			#endregion

			return (int) CApp.E状態処理結果.ステージ継続;
		}
		public override void On描画( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			// Global.App.tDirect3Dデバイスをクリアする();
			
			#region [ 背景動画 ]
			//-----------------
			if( this.ds背景動画 != null &&
				this.tx背景動画 != null )
			{
				#region [ ウィンドウサイズが変わってたら、拡大率を変更する。]
				//-----------------
				if( Global.Theme.LogicalDisplaySize.Width != this.ds背景動画.n幅px ||
					Global.Theme.LogicalDisplaySize.Height != this.ds背景動画.n高さpx )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
				//-----------------
				#endregion

				this.ds背景動画.t現時点における最新のスナップイメージをTextureに転写する( this.tx背景動画 );
				this.tx背景動画.t2D描画( D3D9Device, 0, 0 );
			}
			//-----------------
			#endregion
			#region [ 背景 ]
			//-----------------
			if( this.tx背景 != null )
				this.tx背景.t2D描画( D3D9Device, 0, 0 );
			//-----------------
			#endregion
			#region [ 結果パラメータパネル ]
			//-----------------
			if( this.tx結果表示パラメータパネル != null )
				this.tx結果表示パラメータパネル.t2D描画( D3D9Device, 40, 131 );
			//-----------------
			#endregion
			#region [ 結果パラメータ ]
			//-----------------
			var sb文字列 = new StringBuilder();

			int n総数 = 0;
			for( int i = 0; i <= 5; i++ )
				n総数 += Global.Stage.m演奏ステージ.dicヒットした回数[ (E判定) i ];

			for( int i = 0; i <= 5; i++ )
				sb文字列.Append( this.t結果パラメータ文字列を作成する( Global.Stage.m演奏ステージ.dicヒットした回数[ (E判定) i ], n総数 ) );

			this.Act結果パラメータ文字列描画.t表示( D3D9Device, this.tx結果パラメータフォント, 240, 155, sb文字列.ToString() );
			//-----------------
			#endregion
			
			#region [ フェードイン ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードイン )
				this.Actホワイトイン.On描画( Global.App.D3D9Device, this.txWhite );
			//-----------------
			#endregion
			#region [ フェードアウト ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードアウト )
				this.Actブラックアウト.On描画( Global.App.D3D9Device, this.txBlack );
			//-----------------
			#endregion
		}

		#region [ protected ]
		//-----------------
		protected CMActフェードイン・透明度 Actホワイトイン;
		protected CTexture txWhite;
		protected CMActフェードアウト・透明度 Actブラックアウト;
		protected CTexture txBlack;
		protected volatile CDirectShow ds背景動画 = null;
		protected CTexture tx背景動画 = null;
		protected CTexture tx背景 = null;
		protected CTexture tx結果表示パラメータパネル = null;
		protected CMAct文字列描画 Act結果パラメータ文字列描画 = null;
		protected CTexture tx結果パラメータフォント = null;

		protected string t結果パラメータ文字列を作成する( int n値, int n総数 )
		{
			var sb = new StringBuilder( 32 );
			
			sb.Append( n値.ToString( "00000" ) );
			for( int n桁 = 0; n桁 < 4; n桁++ )
			{
				if( sb[ n桁 ] == '0' )
					sb[ n桁 ] = '*';
				else
					break;
			}
			sb.Append( string.Format( "({0,5:F1}%)\n", ( (double) n値 * 100.0 / (double) n総数 ) ) );

			return sb.ToString();
		}
		//-----------------
		#endregion
	}
}
