﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Diagnostics;
using System.IO;
using System.Windows.Forms;
using System.Threading;
using SlimDX;
using SlimDX.DirectInput;
using FDK;

namespace StrokeStyleT
{
	class C選曲ステージ : CStageBase
	{
		public C選曲ステージ()
		{
			this.list子Activities.Add( this.Actホワイトイン = new CMActフェードイン・透明度( 1 ) );

			this.eStageID = EステージID.選曲;
			this.ePhaseID = EフェーズID.通常;
		}

		public void t選択曲を最初の曲にリセットする()
		{
			// Global.SongList が再構築された後に呼び出されることを想定している。
			// 本ステージが活性化してるか否かに関係無く呼び出されるので注意。

			this.list現在の曲リスト = Global.Song.list曲リスト;
			this.stackBOXの曲番号 = new Stack<int>();
			this.n現在の選択曲番号 = 0;	// ツリールートにおける選択曲の Song番号をstackに格納。
			this.n現在の中心曲番号 = 0;
			this.nカーソルY位置0to2 = 1;
		}
		public void t現在の中心曲を起点として曲番号マップを更新する()
		{
			// マップをクリア。

			for( int i = 0; i < 9 * 3; i++ )
				this.ar曲番号マップ[ ( i % 9 ), ( i / 9 ) ] = 0;


			// 曲がないならここで終わり。

			if( this.list現在の曲リスト.Count == 0 )
				return;


			// 中心曲番号を起点にマップを生成する。

			// △□□□□□□□△		-13 -10 -7 -4 -1 ２ ５ ８ 11	０が中心曲。（≠選択曲の場合あり）
			// △□□□□□□□△	→	-12  -9 -6 -3 ０ ３ ６ ９ 12	■が選択曲。（≠中心曲の場合あり）
			// △□□□■□□□△		-11  -8 -5 -2 １ ４ ７ 10 13	△は画面外。

			for( int i = 0; i < 9 * 3; i++ )
				this.ar曲番号マップ[ ( i / 3 ), ( i % 3 ) ] = this.t中心曲から指定された相対数だけ離れた曲番号を返す( i - 13 );
		}
		public void t選曲し直す()
		{
			this.b曲決定 = false;
		}

		public override void On活性化( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してる )
				return;

			this.n目標のスクロールカウンタ = 0;
			this.n現在のスクロールカウンタ = 0;
			this.b曲決定 = false;
			this.mスクロールアニメ用一定間隔処理 = new C一定間隔処理();

			if( this.list現在の曲リスト == null )			// 曲リストや選択曲、中心曲などは、t選択曲を最初の曲にリセットする() を
				this.t選択曲を最初の曲にリセットする();		// 呼び出さない限り、ステージが変わっても維持され続ける。

			this.sdカーソル移動音 = Global.SoundDevice.tサウンドを作成する( Global.Theme.tファイルパス( @"ScreenSelect cursor move.wav" ) );
			this.sd曲決定音 = Global.SoundDevice.tサウンドを作成する( Global.Theme.tファイルパス( @"ScreenSelect decide.wav" ) );
			this.ds背景動画 = Global.t失敗してもスキップ可能なDirectShowを生成する( Global.Theme.tファイルパス( @"ScreenSelect BGV.mp4" ), Global.App.hWnd, true );

			this.ePhaseID = EフェーズID.フェードイン;
			base.On活性化( D3D9Device );
		}
		public override void On非活性化()
		{
			if( this.b活性化してない )
				return;

			C共通.tDisposeする( this.FPS ); this.FPS = null;
			C共通.tDisposeする( this.VPS ); this.VPS = null;
			C共通.tDisposeする( ref this.mスクロールアニメ用一定間隔処理 );
			C共通.tDisposeする( this.sdカーソル移動音 ); this.sdカーソル移動音 = null;
			C共通.tDisposeする( this.sd曲決定音 ); this.sd曲決定音 = null;
			C共通.tDisposeする( this.ds背景動画 ); this.ds背景動画 = null;

			base.On非活性化();
		}
		public override void OnManagedリソースの作成( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			// サムネイルテクスチャを復元。

			int nKeys = this.dicThumbnail.Count;
			string[] keys = new string[ nKeys ];
			this.dicThumbnail.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
				this.dicThumbnail[ key ] = this.tサムネイルテクスチャを作成する( Path.GetDirectoryName( key ) );


			// プロパティテクスチャを復元。

			nKeys = this.dicProperty.Count;
			keys = new string[ nKeys ];
			this.dicProperty.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
				this.dicProperty[ key ] = this.tプロパティテクスチャを作成する( key );


			// その他を復元。

			this.txブランク画像 = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect blank image.png" ) );
			this.txSongNotFound = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect song not found.png" ) );
			this.txWhite = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"White 64x64.png" ) );
			this.txヘッダ = Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect header.png" ) );

			#region [ 活性化時に背景動画が生成されている場合は背景動画用テクスチャを作成する。]
			//-----------------
			if( this.ds背景動画 != null )
			{
				this.tx背景動画 = Global.tテクスチャを生成する( this.ds背景動画.n幅px, this.ds背景動画.n高さpx );

				if( this.tx背景動画 != null )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
			}
			else
				this.tx背景動画 = null;
			//-----------------
			#endregion

			base.OnManagedリソースの作成( D3D9Device );
		}
		public override void OnManagedリソースの解放()
		{
			if( this.b活性化してない )
				return;


			// サムネイルテクスチャを解放。

			int nKeys = this.dicThumbnail.Count;
			string[] keys = new string[ nKeys ];
			this.dicThumbnail.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
			{
				C共通.tDisposeする( this.dicThumbnail[ key ] );
				this.dicThumbnail[ key ] = null;
			}


			// プロパティテクスチャを解放。

			nKeys = this.dicProperty.Count;
			keys = new string[ nKeys ];
			this.dicProperty.Keys.CopyTo( keys, 0 );
			foreach( var key in keys )
			{
				C共通.tDisposeする( this.dicProperty[ key ] );
				this.dicProperty[ key ] = null;
			}


			// その他を解放。

			C共通.tDisposeする( ref this.txブランク画像 );
			C共通.tDisposeする( ref this.txSongNotFound );
			C共通.tDisposeする( ref this.tx背景動画 );
			C共通.tDisposeする( ref this.txWhite );
			C共通.tDisposeする( ref this.txヘッダ );

			base.OnManagedリソースの解放();
		}
		public override int On進行()
		{
			if( this.b活性化してない )
				return (int) CApp.E状態処理結果.ステージ継続;


			// 進行。

			#region [ 初めての進行処理。]
			//-----------------
			if( this.b初めての進行 )
			{
				if( this.ds背景動画 != null )
				{
					this.ds背景動画.bループ再生 = true;
					this.ds背景動画.t再生開始();
				}

				// FPS/VPS 測定開始。

				this.FPS = new CFPS();
				this.VPS = new CFPS();

				this.Actホワイトイン.t開始();
				this.b初めての進行 = false;
			}
			//-----------------
			#endregion

			#region [ スクロールアニメの進行と曲番号マップの更新。]
			//-----------------
			if( this.list現在の曲リスト.Count > 0 )
			{
				// スクロールを進行。

				this.mスクロールアニメ用一定間隔処理.t進行( 5, () => {

					int n加速度 = 1;
					int n残距離 = Math.Abs( (int) ( this.n目標のスクロールカウンタ - this.n現在のスクロールカウンタ ) );

					#region [ 残距離が遠いほどスクロールを速くする（＝n加速度を多くする）。]
					//-----------------
					if( n残距離 <= 100 )
					{
						n加速度 = 4;
					}
					else if( n残距離 <= 300 )
					{
						n加速度 = 8;
					}
					else if( n残距離 <= 500 )
					{
						n加速度 = 12;
					}
					else
					{
						n加速度 = 16;
					}
					//-----------------
					#endregion

					#region [ 加速度を加算し、現在のスクロールカウンタを目標のスクロールカウンタまで近づける。 ]
					//-----------------
					if( this.n現在のスクロールカウンタ < this.n目標のスクロールカウンタ )		// (A) 正の方向に未達の場合：
					{
						this.n現在のスクロールカウンタ += n加速度;								// カウンタを正方向に移動する。

						if( this.n現在のスクロールカウンタ > this.n目標のスクロールカウンタ )
							this.n現在のスクロールカウンタ = this.n目標のスクロールカウンタ;	// 到着！スクロール停止！
					}
					else if( this.n現在のスクロールカウンタ > this.n目標のスクロールカウンタ )	// (B) 負の方向に未達の場合：
					{
						this.n現在のスクロールカウンタ -= n加速度;								// カウンタを負方向に移動する。

						if( this.n現在のスクロールカウンタ < this.n目標のスクロールカウンタ )	// 到着！スクロール停止！
							this.n現在のスクロールカウンタ = this.n目標のスクロールカウンタ;
					}
					//-----------------
					#endregion

					if( this.n現在のスクロールカウンタ >= 100 )		// １行＝100カウント。
					{
						#region [ 曲マトリックスを右から左へ１列シフトする。]
						//-----------------
						if( this.sdカーソル移動音 != null )
							this.sdカーソル移動音.tサウンドを先頭から再生する();

						this.n現在の中心曲番号 = this.t中心曲から指定された相対数だけ離れた曲番号を返す( -3 );
						this.n現在の選択曲番号 = ( ( this.n現在の中心曲番号 + ( this.nカーソルY位置0to2 - 1 ) ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;

						this.n現在のスクロールカウンタ -= 100;
						this.n目標のスクロールカウンタ -= 100;

						//if( this.n目標のスクロールカウンタ == 0 )
						//	CDTXMania.stage選曲.t選択曲変更通知();		// スクロール完了＝選択曲変更！

						//-----------------
						#endregion
					}
					else if( this.n現在のスクロールカウンタ <= -100 )
					{
						#region [ 曲マトリックスを左から右へ１列シフトする。]
						//-----------------
						if( this.sdカーソル移動音 != null )
							this.sdカーソル移動音.tサウンドを先頭から再生する();

						this.n現在の中心曲番号 = this.t中心曲から指定された相対数だけ離れた曲番号を返す( +3 );
						this.n現在の選択曲番号 = ( ( this.n現在の中心曲番号 + ( this.nカーソルY位置0to2 - 1 ) ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;

						this.n現在のスクロールカウンタ += 100;
						this.n目標のスクロールカウンタ += 100;

						//if( this.n目標のスクロールカウンタ == 0 )
						//	CDTXMania.stage選曲.t選択曲変更通知();		// スクロール完了＝選択曲変更！

						//-----------------
						#endregion
					}
				} );
			}

			// 毎回、最新の情報で更新。

			this.t現在の中心曲を起点として曲番号マップを更新する();
			//-----------------
			#endregion
			#region [ 曲が決定されている場合、終了処理を行う。]
			//-----------------
			if( this.b曲決定 )
			{
				// 決定曲を Global.Song に登録する。
				Global.Song.r現在演奏中の曲 = Global.Song.list曲リスト[ this.n現在の選択曲番号 ];

				return (int) CApp.E状態処理結果.曲決定;
			}
			//-----------------
			#endregion

			if( this.FPS != null ) this.FPS.tカウンタ更新();

			#region [ フェードイン → 完了したら通常フェーズへ ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードイン )
			{
				if( this.Actホワイトイン.b完了 )
					this.ePhaseID = EフェーズID.通常;

				this.Actホワイトイン.On進行();	// 進行は完了チェックの後に！
			}
			//-----------------
			#endregion


			// 入力。

			#region [ ESC or WM_CLOSE → 終了 ]
			//-----------------
			if( Global.Input.Input管理.Keyboard.bキーが押された( Key.Escape ) ||
				Global.App.bWM_CLOSEを受け取った )
			{
				return (int) CApp.E状態処理結果.終了;
			}
			//-----------------
			#endregion


			// 以下のキーは、曲決定後には無効。

			if( !this.b曲決定 )
			{
				#region [ F1 → ユーザ別設定ウィンドウ起動 ]
				//-----------------
				if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F1 ) )
					return (int) CApp.E状態処理結果.ユーザ別設定開始;
				//-----------------
				#endregion
				#region [ F2 → ユーザ別曲管理ウィンドウ起動 ]
				//-----------------
				if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F2 ) )
					return (int) CApp.E状態処理結果.ユーザ別曲管理開始;
				//-----------------
				#endregion
				#region [ F3 → 入力割り当てウィンドウ起動 ]
				//-----------------
				if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F3 ) )
					return (int) CApp.E状態処理結果.入力割り当て開始;
				//-----------------
				#endregion
				#region [ F12 → ユーザ管理ウィンドウ起動 ]
				//-----------------
				if( Global.Input.Input管理.Keyboard.bキーが押された( Key.F12 ) )
				{
					return (int) CApp.E状態処理結果.ログインユーザ変更;
				}
				//-----------------
				#endregion


				// 以下のキーは、曲が１曲以上ある場合のみ有効。

				if( this.list現在の曲リスト.Count > 0 )
				{
					#region [ Enter, シンバル類 → 曲決定 ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.Return ) ||
						Global.Input.bシンバル類のいずれかが押された )
					{
						if( this.sd曲決定音 != null )
							this.sd曲決定音.tサウンドを先頭から再生する();

						if( this.ds背景動画 != null )
							this.ds背景動画.t再生停止();

						this.b曲決定 = true;
						return (int) CApp.E状態処理結果.ステージ継続;	// ここではまだ終わらない。ds曲決定の再生が終わるまで待つ。
					}
					//-----------------
					#endregion
					#region [ 右矢印, FT → 曲マトリックスを右へスクロール ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.RightArrow ) ||
						Global.Input.bフロアタム類のいずれかが押された )
					{
						// 最小でも-800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
						this.n目標のスクロールカウンタ = Math.Max( this.n目標のスクロールカウンタ - 100, -800 );
					}
					//-----------------
					#endregion
					#region [ 左矢印, SD → 曲マトリックスを左へスクロール ]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.LeftArrow ) ||
						Global.Input.bスネア類のいずれかが押された )
					{
						// 最大でも+800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
						this.n目標のスクロールカウンタ = Math.Min( this.n目標のスクロールカウンタ + 100, 800 );
					}
					//-----------------
					#endregion
					#region [ 上矢印, HT → 曲カーソルを上に移動。]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.UpArrow ) ||
						Global.Input.bハイタム類のいずれかが押された )
					{
						if( this.nカーソルY位置0to2 > 0 )
						{
							if( this.sdカーソル移動音 != null )
								this.sdカーソル移動音.tサウンドを先頭から再生する();

							this.nカーソルY位置0to2--;
							this.n現在の選択曲番号 = ( ( this.n現在の選択曲番号 - 1 ) + this.list現在の曲リスト.Count ) % this.list現在の曲リスト.Count;
						}
						else
						{
							this.nカーソルY位置0to2 = 2;

							// 最大でも+800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
							this.n目標のスクロールカウンタ = Math.Min( this.n目標のスクロールカウンタ + 100, 800 );
						}
					}
					//-----------------
					#endregion
					#region [ 下矢印, LT → 曲カーソルを下に移動。]
					//-----------------
					if( Global.Input.Input管理.Keyboard.bキーが押された( Key.DownArrow ) ||
						Global.Input.bロータム類のいずれかが押された )
					{
						if( this.nカーソルY位置0to2 < 2 )
						{
							if( this.sdカーソル移動音 != null )
								this.sdカーソル移動音.tサウンドを先頭から再生する();

							this.nカーソルY位置0to2++;
							this.n現在の選択曲番号 = ( this.n現在の選択曲番号 + 1 ) % this.list現在の曲リスト.Count;
						}
						else
						{
							this.nカーソルY位置0to2 = 0;

							// 最小でも-800まで。（連打をやめると、慣性で最大8列スクロールして停止する。）
							this.n目標のスクロールカウンタ = Math.Max( this.n目標のスクロールカウンタ - 100, -800 );
						}
					}
					//-----------------
					#endregion
				}
			}
			return (int) CApp.E状態処理結果.ステージ継続;
		}
		public override void On描画( SlimDX.Direct3D9.Device D3D9Device )
		{
			if( this.b活性化してない )
				return;

			Global.App.tDirect3Dデバイスをクリアする();		// BeginScene()～EndScene() の中でも外でも問題ないらしい。

			#region [ 曲がないなら Song not found を表示して帰れ。]
			//-----------------
			if( this.list現在の曲リスト.Count == 0 )
			{
				#region [ 背景のブランク枠を表示。]
				//-----------------
				if( this.txブランク画像 != null )
				{
					for( int i = 0; i < 9 * 3; i++ )
					{
						int x = i / 3;
						int y = i % 3;
						var mat = SlimDX.Matrix.Identity;
						mat *= SlimDX.Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
						mat *= SlimDX.Matrix.RotationY( this.stマトリックス座標[ x, y ].rotY );
						mat *= SlimDX.Matrix.Translation(
							this.stマトリックス座標[ x, y ].x * CTexture.f画面比率,
							this.stマトリックス座標[ x, y ].y * CTexture.f画面比率,
							this.stマトリックス座標[ x, y ].z * CTexture.f画面比率 );
						this.txブランク画像.t3D描画( D3D9Device, mat );
					}
				}
				//-----------------
				#endregion
				#region [ Song not found テクスチャを表示。]
				//-----------------
				if( this.txSongNotFound != null )
				{
					this.txSongNotFound.t2D描画( 
						D3D9Device,
						Global.Theme.LogicalDisplaySize.Width / 2 - this.txSongNotFound.sz画像サイズ.Width / 2,
						Global.Theme.LogicalDisplaySize.Height / 2 - this.txSongNotFound.sz画像サイズ.Height / 2 - 40 );	// -40 は背景に合わせた調整値。
				}
				//-----------------
				#endregion

				return;
			}
			//-----------------
			#endregion
			
			#region [ 背景動画 ]
			//-----------------
			if( this.ds背景動画 != null &&
				this.tx背景動画 != null )
			{
				#region [ ウィンドウサイズが変わってたら、拡大率を変更する。]
				//-----------------
				if( Global.Theme.LogicalDisplaySize.Width != this.ds背景動画.n幅px ||
					Global.Theme.LogicalDisplaySize.Height != this.ds背景動画.n高さpx )
				{
					this.tx背景動画.vc拡大縮小倍率 = new Vector3(
						( (float) Global.Theme.LogicalDisplaySize.Width / (float) this.ds背景動画.n幅px ),
						( (float) Global.Theme.LogicalDisplaySize.Height / (float) this.ds背景動画.n高さpx ),
						1.0f );
				}
				//-----------------
				#endregion

				this.ds背景動画.t現時点における最新のスナップイメージをTextureに転写する( this.tx背景動画 );
				this.tx背景動画.t2D描画( D3D9Device, 0, 0 );
			}
			//-----------------
			#endregion
			#region [ 曲マトリックス；ar曲番号マップ[,] に従って描画する。]
			//-----------------
			for( int i = 0; i < 9 * 3 + 1; i++ )
			{
				int mx = i / 3;
				int my = i % 3;

				if( ( mx == 0 && this.n現在のスクロールカウンタ < 0 ) ||	// 最左列は、左に移動中なら表示しない。
					( mx == 8 && this.n現在のスクロールカウンタ > 0 ) )		// 最右列は、右に移動中なら表示しない。
					continue;

				#region [ 選択パネルは一番最後に表示する。]
				//-----------------
				if( mx == 4 && my == this.nカーソルY位置0to2 )		// 選択パネルは描画せずにスキップし、一番最後に回す。
					continue;

				if( i == 9 * 3 + 1 - 1 )			// 一番最後。
				{
					mx = 4;							// 中央
					my = this.nカーソルY位置0to2;	//
				}
				//-----------------
				#endregion

				var song = this.list現在の曲リスト[ this.ar曲番号マップ[ mx, my ] ];

				int dx = ( this.n現在のスクロールカウンタ == 0 ) ? 0 : ( ( this.n現在のスクロールカウンタ < 0 ) ? -1 : +1 );
				float f割合 = Math.Abs( this.n現在のスクロールカウンタ ) / 100.0f;

				#region [ サムネイルを描画。]
				//-----------------
				CTexture txTumbnail = null;

				#region [ サムネイルがないなら作成する。]
				//-----------------
				if( !this.dicThumbnail.ContainsKey( song.ScoreFile ) )
				{
					txTumbnail = this.tサムネイルテクスチャを作成する( Path.GetDirectoryName( song.ScoreFile ) );
					this.dicThumbnail.Add( song.ScoreFile, txTumbnail );
				}
				//-----------------
				#endregion

				txTumbnail = this.dicThumbnail[ song.ScoreFile ];
				if( txTumbnail != null )
				{
					float f拡大率 = this.t曲が選択されている( mx, my ) ? 1.25f : 1.0f;
					var mat = SlimDX.Matrix.Identity;
					mat *= SlimDX.Matrix.Scaling( f拡大率 * CTexture.f画面比率, f拡大率 * CTexture.f画面比率, 1.0f );
					mat *= SlimDX.Matrix.RotationY( this.stマトリックス座標[ mx, my ].rotY + ( this.stマトリックス座標[ mx + dx, my ].rotY - this.stマトリックス座標[ mx, my ].rotY ) * f割合 );
					mat *= SlimDX.Matrix.Translation(
						( this.stマトリックス座標[ mx, my ].x + (int) ( ( this.stマトリックス座標[ mx + dx, my ].x - this.stマトリックス座標[ mx, my ].x ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].y + (int) ( ( this.stマトリックス座標[ mx + dx, my ].y - this.stマトリックス座標[ mx, my ].y ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].z + (int) ( ( this.stマトリックス座標[ mx + dx, my ].z - this.stマトリックス座標[ mx, my ].z ) * f割合 ) ) * CTexture.f画面比率 );
					txTumbnail.t3D描画( D3D9Device, mat );
				}
				//-----------------
				#endregion
				#region [ プロパティを描画。]
				//-----------------
				CTexture txProperty = null;

				#region [ プロパティがないなら作成する。]
				//-----------------
				if( !this.dicProperty.ContainsKey( song.ScoreFile ) )
				{
					txProperty = this.tプロパティテクスチャを作成する( song.ScoreFile );
					this.dicProperty.Add( song.ScoreFile, txProperty );
				}
				//-----------------
				#endregion

				txProperty = this.dicProperty[ song.ScoreFile ];
				if( txProperty != null )
				{
					var mat = SlimDX.Matrix.Identity;
					mat *= SlimDX.Matrix.Scaling( CTexture.f画面比率, CTexture.f画面比率, 1.0f );
					mat *= SlimDX.Matrix.RotationY( this.stマトリックス座標[ mx, my ].rotY + ( this.stマトリックス座標[ mx + dx, my ].rotY - this.stマトリックス座標[ mx, my ].rotY ) * f割合 );
					int nサムネイルとの距離 = 8 + ( this.t曲が選択されている( mx, my ) ? 4 : 0 );
					mat *= SlimDX.Matrix.Translation(
						( this.stマトリックス座標[ mx, my ].x + (int) ( ( this.stマトリックス座標[ mx + dx, my ].x - this.stマトリックス座標[ mx, my ].x ) * f割合 ) ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].y + (int) ( ( this.stマトリックス座標[ mx + dx, my ].y - this.stマトリックス座標[ mx, my ].y ) * f割合 )
							- Global.Theme.m演奏ステージ.Thumbnail.Height / 2 - Global.Theme.m演奏ステージ.ThumbnailProperty.Height / 2 - nサムネイルとの距離 ) * CTexture.f画面比率,
						( this.stマトリックス座標[ mx, my ].z + (int) ( ( this.stマトリックス座標[ mx + dx, my ].z - this.stマトリックス座標[ mx, my ].z ) * f割合 ) ) * CTexture.f画面比率 );
					txProperty.t3D描画( D3D9Device, mat );
				}
				//-----------------
				#endregion
			}
			//-----------------
			#endregion
			#region [ 操作メモ；超簡単な操作メモを下部に表示。]
			//-----------------
			Global.Act英数字描画.t表示( D3D9Device, 16, Global.Theme.LogicalDisplaySize.Height - 32, CAct英数字描画.E種別.白,
				"F1:Settings, F2:SongList, F3:AssignDrums, F12:ChangeUser" );
			Global.Act英数字描画.t表示( D3D9Device, 16, Global.Theme.LogicalDisplaySize.Height - 32 - 16, CAct英数字描画.E種別.白,
				"Cursor: MoveCursor, Enter:DecideSong, ESC:Exit" );
			//-----------------
			#endregion
			#region [ FPS(VPS) ]
			//-----------------
			if( this.VPS != null )	// 曲が再生されるまでは、この描画メソッドは呼ばれるが VPS は生成されていない。
				this.VPS.tカウンタ更新();

			if( this.FPS != null && this.VPS != null )
			{
				string msg = string.Format( "FPS(VPS): {0}({1})", this.FPS.n現在のFPS, this.VPS.n現在のFPS );
				int n幅 = msg.Length * 8;
				Global.Act英数字描画.t表示( D3D9Device, Global.Theme.LogicalDisplaySize.Width - n幅, Global.Theme.LogicalDisplaySize.Height - 16, CAct英数字描画.E種別.白太, msg );
			}
			//-----------------
			#endregion
			#region [ ヘッダ ]
			//-----------------
			if( this.txヘッダ != null )
				this.txヘッダ.t2D描画( D3D9Device, 0, 0 );
			//-----------------
			#endregion
			#region [ フェードイン ]
			//-----------------
			if( this.ePhaseID == EフェーズID.フェードイン )
				this.Actホワイトイン.On描画( Global.App.D3D9Device, this.txWhite );
			//-----------------
			#endregion
		}

		#region [ protected ]
		//-----------------
		protected volatile bool b曲決定 = false;
		/// <summary>
		/// <para>現在選択中のSongが含まれるSongリスト。</para>
		/// <para>初期値はツリールート。BOXを出たり入ったりするたび更新される。</para>
		/// </summary>
		protected volatile List<SongNode> list現在の曲リスト = null;
		
		/// <summary>
		/// <para>現在選択されているSong番号。</para>
		/// <para>この番号は、C選曲ステージ.list現在の曲リスト[] のインデックスを示す。</para>
		/// </summary>
		protected int n現在の選択曲番号
		{
			get
			{
				if( this.stackBOXの曲番号 == null ||
					this.stackBOXの曲番号.Count == 0 )
				{
					throw new InvalidOperationException( "stackBOXの曲番号 が null または中身が空です。" );
				}

				return this.stackBOXの曲番号.Peek();
			}
			set
			{
				if( this.stackBOXの曲番号 == null )
					throw new NullReferenceException( "stackBOXの曲番号 が null です。" );


				// 先頭要素を置換。

				if( this.stackBOXの曲番号.Count > 0 )	// 先頭要素があれば除去。
					this.stackBOXの曲番号.Pop();

				this.stackBOXの曲番号.Push( value );	// 新しい要素を格納。
			}
		}

		protected volatile CFPS FPS;
		protected volatile CFPS VPS;
		protected volatile CSound sdカーソル移動音 = null;
		protected volatile CSound sd曲決定音 = null;
		protected volatile CDirectShow ds背景動画 = null;
		protected CTexture tx背景動画 = null;
		protected CMActフェードイン・透明度 Actホワイトイン;
		protected CTexture txWhite;
		protected CTexture txヘッダ;

		/// <summary>
		/// <para>3行7列（[7,3]）の曲番号の配列。</para>
		/// <para>△□□□□□△　　０が中心曲。（≠選択曲の場合あり）</para>
		/// <para>△□□□□□△　　■が選択曲。（≠中心曲の場合あり）</para>
		/// <para>△□□■□□△　　△は画面外。</para>
		/// </summary>
		protected int[,] ar曲番号マップ = new int[ 9, 3 ];

		/// <summary>
		/// <para>曲リスト（マトリックス）表示のための基準点。</para>
		/// </summary>
		protected int n現在の中心曲番号 = 0;
		
		/// <summary>
		/// <para>SSTFファイル絶対パス(key)とサムネイル画像(value)との辞書。</para>
		/// <para>アプリの起動から終了まで単純に増加を続け、要素が減ることはない。</para>
		/// </summary>
		protected Dictionary<string, CTexture> dicThumbnail = new Dictionary<string, CTexture>();
		
		/// <summary>
		/// <para>SSTFファイル絶対パス(key)とプロパティ画像(value)との辞書。</para>
		/// <para>アプリの起動から終了まで単純に増加を続け、要素が減ることはない。</para>
		/// </summary>
		protected Dictionary<string, CTexture> dicProperty = new Dictionary<string, CTexture>();

		protected CTexture txブランク画像 = null;
		protected CTexture txSongNotFound = null;

		protected int nカーソルY位置0to2;
		protected int n現在のスクロールカウンタ;
		protected int n目標のスクロールカウンタ;
		protected C一定間隔処理 mスクロールアニメ用一定間隔処理;

		protected struct ST中心点
		{
			public float x;
			public float y;
			public float z;
			public float rotY;
		}
		protected readonly ST中心点[,] stマトリックス座標 = new ST中心点[ 9, 3 ] {
			#region [ 実は円弧配置になってない。射影行列間違ってるよスターレインボウ見せる気かよ… ]
			//-----------------
			{ new ST中心点() { x = -533.8936f, y = 210f, z = -289.5575f, rotY = -0.9279888f },
				new ST中心点() { x = -533.8936f, y = 50f, z = -289.5575f, rotY = -0.9279888f },
				new ST中心点() { x = -533.8936f, y = -110f, z = -289.5575f, rotY = -0.9279888f } },
			{ new ST中心点() { x = -423.8936f, y = 210f, z = -169.5575f, rotY = -0.6579891f },
				new ST中心点() { x = -423.8936f, y = 50f, z = -169.5575f, rotY = -0.6579891f },
				new ST中心点() { x = -423.8936f, y = -110f, z = -169.5575f, rotY = -0.6579891f } },
			{ new ST中心点() { x = -297.5025f, y = 210f, z = -74.37564f, rotY = -0.4808382f },
				new ST中心点() { x = -297.5025f, y = 50f, z = -74.37564f, rotY = -0.4808382f },
				new ST中心点() { x = -297.5025f, y = -110f, z = -74.37564f, rotY = -0.4808382f } },
			{ new ST中心点() { x = -153.9001f, y = 210f, z = -20.52002f, rotY = -0.2605f },
				new ST中心点() { x = -153.9001f, y = 50f, z = -20.52002f, rotY = -0.2605f },
				new ST中心点() { x = -153.9001f, y = -110f, z = -20.52002f, rotY = -0.2605f } },
			{ new ST中心点() { x = 0.00002622683f, y = 210f, z = 0f, rotY = 0f }, 
				new ST中心点() { x = 0.00002622683f, y = 50f, z = 0f, rotY = 0f }, 
				new ST中心点() { x = 0.00002622683f, y = -110f, z = 0f, rotY = 0f } },
			{ new ST中心点() { x = 153.9002f, y = 210f, z = -20.52002f, rotY = 0.2605f },
				new ST中心点() { x = 153.9002f, y = 50f, z = -20.52002f, rotY = 0.2605f },
				new ST中心点() { x = 153.9002f, y = -110f, z = -20.52002f, rotY = 0.2605f } },
			{ new ST中心点() { x = 297.5025f, y = 210f, z = -74.37564f, rotY = 0.4808382f },
				new ST中心点() { x = 297.5025f, y = 50f, z = -74.37564f, rotY = 0.4808382f },
				new ST中心点() { x = 297.5025f, y = -110f, z = -74.37564f, rotY = 0.4808382f } },
			{ new ST中心点() { x = 423.8936f, y = 210f, z = -169.5575f, rotY = 0.6579891f },
				new ST中心点() { x = 423.8936f, y = 50f, z = -169.5575f, rotY = 0.6579891f },
				new ST中心点() { x = 423.8936f, y = -110f, z = -169.5575f, rotY = 0.6579891f } },
			{ new ST中心点() { x = 533.8936f, y = 210f, z = -289.5575f, rotY = 0.9279888f },
				new ST中心点() { x = 533.8936f, y = 50f, z = -289.5575f, rotY = 0.9279888f },
				new ST中心点() { x = 533.8936f, y = -110f, z = -289.5575f, rotY = 0.9279888f } },
			//-----------------
			#endregion
		};

		protected int t中心曲から指定された相対数だけ離れた曲番号を返す( int n相対数 )
		{
			int n曲番号 = this.n現在の中心曲番号 + n相対数;
			int n曲数 = this.list現在の曲リスト.Count;

			// リストは、正方向にも負方向にも循環する。

			while( n曲番号 < 0 )	
				n曲番号 += n曲数;

			return n曲番号 % n曲数;
		}
		protected CTexture tサムネイルテクスチャを作成する( string strフォルダパス )
		{
			string[] files = Directory.GetFiles( strフォルダパス, "thumb.*" );
			foreach( var file in files )
			{
				string ext = Path.GetExtension( file ).ToLower();

				if( ext.Equals( ".jpg" ) || ext.Equals( ".jpeg" ) ||	// 片っ端から放り込んでログが例外の山になるものウザイし、
					ext.Equals( ".png" ) ||								// とりあえず対応拡張子はこれだけにしておく。
					ext.Equals( ".bmp" ) )
				{
					const int n縁の幅px = 6;
					using( var bmpFromfile = new Bitmap( file ) )
					using( var bmp = new Bitmap( Global.Theme.m演奏ステージ.Thumbnail.Width + n縁の幅px * 2, Global.Theme.m演奏ステージ.Thumbnail.Height + n縁の幅px * 2 ) )
					using( var g = Graphics.FromImage( bmp ) )
					{
						g.FillRectangle( Brushes.Black, 0, 0, bmp.Width, bmp.Height );

						#region [ bmpFromFile を、bmp 内部に収まり、センタリングされる位置に描画する。小さい画像は拡大し、大きい画像は縮小する。]
						//-----------------
						int w = bmpFromfile.Width;
						int h = bmpFromfile.Height;

						if( w > h )
						{
							h = (int) ( h * (double) ( bmp.Width - n縁の幅px * 2 ) / (double) w );
							w = bmp.Width - n縁の幅px * 2;
						}
						else
						{
							w = (int) ( w * (double) ( bmp.Height - n縁の幅px * 2 ) / (double) h );
							h = bmp.Height - n縁の幅px * 2;
						}
						int x = ( bmp.Width - w ) / 2;
						int y = ( bmp.Height - h ) / 2;

						g.InterpolationMode = System.Drawing.Drawing2D.InterpolationMode.Bicubic;
						g.DrawImage( bmpFromfile, new Rectangle( x, y, w, h ) );
						//-----------------
						#endregion
						#region [ 画像を縁取る。]
						//-----------------
						g.FillRectangle( Brushes.White, new Rectangle( 0, 0, n縁の幅px, bmp.Height ) );
						g.FillRectangle( Brushes.White, new Rectangle( bmp.Width - n縁の幅px, 0, n縁の幅px, bmp.Height ) );
						g.FillRectangle( Brushes.White, new Rectangle( 0, 0, bmp.Width, n縁の幅px ) );
						g.FillRectangle( Brushes.White, new Rectangle( 0, bmp.Height - n縁の幅px, bmp.Width, bmp.Height ) );
						int n幅 = n縁の幅px / 2;
						g.FillRectangle( Brushes.Black, new Rectangle( 0, 0, n幅, bmp.Height ) );
						g.FillRectangle( Brushes.Black, new Rectangle( bmp.Width - n幅, 0, n幅, bmp.Height ) );
						g.FillRectangle( Brushes.Black, new Rectangle( 0, 0, bmp.Width, n幅 ) );
						g.FillRectangle( Brushes.Black, new Rectangle( 0, bmp.Height - n幅, bmp.Width, bmp.Height ) );
						
						//-----------------
						#endregion

						return Global.tテクスチャを生成する( bmp );
					}
				}
			}

			return Global.tテクスチャを生成する( Global.Theme.tファイルパス( @"ScreenSelect no image.png" ) );
		}
		protected CTexture tプロパティテクスチャを作成する( string str曲ファイルパス )
		{
			// スコアのヘッダを読み込む。

			var score = new Cスコア();
			try
			{
				score.t曲データファイルを読み込む・ヘッダだけ( str曲ファイルパス );
			}
			catch
			{
				#region [ 読み込み失敗 → 空のテクスチャを返す。]
				//-----------------
				CTexture txBlank = null;
				using( var bmp = new Bitmap( Global.Theme.m演奏ステージ.ThumbnailProperty.Width, Global.Theme.m演奏ステージ.ThumbnailProperty.Height ) )
				{
					txBlank = Global.tテクスチャを生成する( bmp );
				}
				return txBlank;
				//-----------------
				#endregion
			}


			// プロパティテクスチャを作成。

			CTexture txProperty = null;

			using( var bmp = new Bitmap( Global.Theme.m演奏ステージ.ThumbnailProperty.Width, Global.Theme.m演奏ステージ.ThumbnailProperty.Height ) )
			using( var g = Graphics.FromImage( bmp ) )
			using( var font = new Font( FontFamily.GenericSerif, 12.0f ) )
			using( var format = new StringFormat() { Alignment = StringAlignment.Center } )
			using( var br背景 = new LinearGradientBrush(
				g.VisibleClipBounds,
				Color.FromArgb( 255, 255, 144, 0 ),	// 上
				Color.FromArgb( 0, 0, 0, 0 ),		// 下
				LinearGradientMode.Vertical ) )
			using( var br文字本体 = new SolidBrush( Color.Black ) )
			using( var br文字縁 = new SolidBrush( Color.White ) )
			using( var pen = new Pen( br文字縁, 5.0f ) )
			using( var path = new GraphicsPath() )
			{
				var rc = new RectangleF( 0f, 0f, (float) bmp.Width, (float) bmp.Height );

				g.FillRectangle( br背景, rc );
				g.SmoothingMode = SmoothingMode.HighQuality;

				rc.Y += 4;			// 4 はマージン
				rc.Height -= 4;		//
				path.AddString( score.Header.str曲名, font.FontFamily, (int) font.Style, font.Size, rc, format );
				g.DrawPath( pen, path );
				g.FillPath( br文字本体, path );

				txProperty = Global.tテクスチャを生成する( bmp );
			}

			return txProperty;
		}
		//-----------------
		#endregion

		#region [ private ]
		//-----------------
		/// <summary>
		/// <para>BOXに入ったときの Global.Song.list曲リスト の曲番号（配列のインデックス）を階層的に記憶しておくための LIFO 。</para>
		/// <para>BOXに入るたびその BOX の曲番号を Push し、BOX から出るたび親 BOX の曲番号を Pop する。</para>
		/// <para>最初に Push されるのは、ツリールートの先頭曲番号(=0)。</para>
		/// <para>このスタックは基本的に C演奏ステージ.n現在の選択曲番号 プロパティで制御するため、private に置いておく。</para>
		/// </summary>
		private Stack<int> stackBOXの曲番号 = null;

		private bool t曲が選択されている( int mx0to8, int my0to2 )
		{
			return ( mx0to8 == 4 && my0to2 == this.nカーソルY位置0to2 );
		}
		//-----------------
		#endregion
	}
}

