﻿using System;
using System.Collections.Generic;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Diagnostics;
using System.IO;
using SlimDX.DirectInput;
using FDK;

namespace StrokeStyleT
{
	public partial class Cユーザ別曲管理ウィンドウ : Form
	{
		public DialogResult dialogResult = DialogResult.OK;

		public Cユーザ別曲管理ウィンドウ()
		{
			InitializeComponent();
		}
		public void tメイン処理()
		{
			// 設定ウィンドウの初期化

			#region [ すべてのSongListについてツリーと対応表に追加 ]
			//-----------------
			this.dicノードSong対応表 = new Dictionary<TreeNode, SongNode>();

			this.treeView曲ツリー.Nodes.Clear();
			foreach( var strマクロ付きSongListファイル名 in Global.Users.Config.SongListFiles )
				this.tSongListファイルを追加する( Global.Folder.tファイルパスのマクロを展開する( strマクロ付きSongListファイル名 ) );
			//-----------------
			#endregion

			this.tGUIのEnableを設定する();


			// デバイスに変更を与えるパラメータについて、変更前の値を保存する。

			bool Windowed設定前 = Global.Users.Config.Windowed;
			bool VSyncwait設定前 = Global.Users.Config.VSyncWait;

			#region [ 設定ウィンドウの表示と入力処理タイマスレッドの実行 ]
			//-----------------
			using( Global.Input.Input管理 = new CInput管理( this.Handle ) )	// このウィンドウ上でのInput管理を開始。
			using( this.Timer = new Timer() )
			{
				this.Timer.Tick += ( o, args ) => { Global.Input.tドラムでFormを操作する( this ); };
				this.Timer.Start();

				// モーダルモードで起動する。閉じるまで処理が帰ってこない。が、Idleイベントは起きるためメインループは並行して進行するので注意する。
				this.dialogResult = this.ShowDialog( Global.App.Window );

				this.Timer.Stop();
			}

			this.Select();
			//-----------------
			#endregion

			#region [ 確定処理 ]
			//-----------------
			if( this.dialogResult == DialogResult.OK )
			{
				#region [ Config への反映 ]
				//-----------------
				Global.Users.Config.SongListFiles.Clear();
				foreach( TreeNode node in this.treeView曲ツリー.Nodes )		// この Nodes の中身はすべてSongListノードである
					Global.Users.Config.SongListFiles.Add( Global.Folder.tファイルパスのマクロを展開する( node.Text ) );
				//-----------------
				#endregion

				#region [ Configファイルの保存 ]
				//-----------------
				Global.Users.Config.t保存する( Global.Folder.strConfigXMLの絶対パス );
				//-----------------
				#endregion

				#region [ SongListファイルへの反映と保存 ]
				//-----------------
				foreach( TreeNode node in this.treeView曲ツリー.Nodes )		// この Nodes の中身はすべてSongListノードである
				{
					var songList = new SongList() {
						Songs = new List<SongNode>(),
					};
					this.tGUIツリーからSongツリーを再帰的に構築する( node.Nodes, songList.Songs );

					songList.t保存する( Global.Folder.tファイルパスのマクロを展開する( node.Text ) );
				}
				//-----------------
				#endregion

				// 選択ステージの曲リスト（Global.Song.list曲リスト）の再構築

				Global.Song.t曲リストをクリアしConfigに記されているSongListをすべて読み込んでマージする();
			}
			//-----------------
			#endregion
		}

		#region [ protected ]
		//-----------------
		protected Dictionary<TreeNode, SongNode> dicノードSong対応表;
		protected Timer Timer = null;
		protected string str最後に開いたフォルダ = Global.Folder.strユーザ個別フォルダ;

		protected void tGUIのEnableを設定する()
		{
			#region [ SongListが１つ以上あるときのみ有効になるGUI。]
			//-----------------
			bool bSongListが１つ以上ある = false;
			foreach( TreeNode node in this.treeView曲ツリー.Nodes )
			{
				if( !this.dicノードSong対応表.ContainsKey( node ) )		// SongListノードは対応表には入れない仕様。
				{
					bSongListが１つ以上ある = true;
					break;
				}
			}

			this.button曲を追加.Enabled = bSongListが１つ以上ある;
			this.buttonフォルダ内指定して曲を追加.Enabled = bSongListが１つ以上ある;
			this.buttonBOXを作成.Enabled = bSongListが１つ以上ある;
			//-----------------
			#endregion
			#region [ ノード選択中であるときのみ有効になるGUI。]
			//-----------------
			bool bノード選択中 = (
				this.treeView曲ツリー.Nodes.Count > 0 &&
				this.treeView曲ツリー.SelectedNode != null );

			this.buttonSongList上へ.Enabled = bノード選択中;
			this.buttonSongList下へ.Enabled = bノード選択中;
			this.button選択項目をリストから除去.Enabled = bノード選択中;
			//-----------------
			#endregion
			#region [ ノードが BOX 内にあるときのみ有効になるGUI。]
			//-----------------
			bool bノードがBOX内にある = (
				this.treeView曲ツリー.Nodes.Count > 0 &&
				this.treeView曲ツリー.SelectedNode != null &&
				this.treeView曲ツリー.SelectedNode.Parent != null &&
				this.dicノードSong対応表.ContainsKey( this.treeView曲ツリー.SelectedNode.Parent ) );	// SongListノードは対応表には入れない仕様。


			this.button選択項目をBOXから出す.Enabled = bノードがBOX内にある;
			//-----------------
			#endregion
			#region [ Song の同一層１つ上が BOX ノードであるときのみ有効になるGUI。]
			//-----------------
			bool bノードがBOXノードの直下にある = (
				this.treeView曲ツリー.Nodes.Count > 0 &&
				this.treeView曲ツリー.SelectedNode != null &&
				this.treeView曲ツリー.SelectedNode.PrevNode != null &&
				this.dicノードSong対応表.ContainsKey( this.treeView曲ツリー.SelectedNode.PrevNode ) &&	// SongListノードは対応表には入れない仕様。
				this.dicノードSong対応表[ this.treeView曲ツリー.SelectedNode.PrevNode ].e種別 == SongNode.E種別.BOX );

			this.button選択項目をBOXに入れる.Enabled = bノードがBOXノードの直下にある;
			//-----------------
			#endregion
		}
		protected bool bSongListノードである( TreeNode node )
		{
			return !this.dicノードSong対応表.ContainsKey( node );
		}
		protected int nImageIndexを返す( string key )
		{
			return 0;// this.imageListツリーノード.Images.IndexOfKey( key );
		}
		protected void tSongListファイルを追加する( string str生SongListファイル名 )
		{
			var strマクロ付きSongListファイル名 = Global.Folder.tファイルパスをマクロ付きパスに逆展開する( str生SongListファイル名 );

			SongList songList = null;

			#region [ SongListファイルの読み込み ]
			//-----------------
			songList = SongList.t読み込む( str生SongListファイル名 );

			if( songList == null )
				return;	// 読み込みに失敗したら無視。
			//-----------------
			#endregion

			#region [ SongListの内容をツリーならびに対応表にすべて追加 ]
			//-----------------

			// ツリー修正開始。

			this.treeView曲ツリー.BeginUpdate();


			// SongList ノードを追加。（SongListノードは対応表には追加しないものとする。）

			int imageIndex = this.nImageIndexを返す( "SongList_Opened" );
			var node = new TreeNode() {
				Text = strマクロ付きSongListファイル名,
				ImageIndex = imageIndex,
				SelectedImageIndex = imageIndex,
			};

			this.treeView曲ツリー.Nodes.Add( node );


			// SongList 配下の Songs をツリー＆対応表に追加。

			this.tツリーに再帰的にアイテムを追加する( node.Nodes, songList.Songs );


			// SongListノードにフォーカス。

			node.Expand();	// ツリーは開く
			this.treeView曲ツリー.SelectedNode = node;
			this.treeView曲ツリー.Select();


			// ツリー修正終了。

			this.treeView曲ツリー.EndUpdate();
			//-----------------
			#endregion
		}
		protected void t曲ファイルを追加する( string str生曲ファイル名, TreeNodeCollection parentNodes, int n挿入位置 )
		{
			// ファイルをヘッダだけ読み込んでスコアを構築。

			var score = new Cスコア();
			score.t曲データファイルを読み込む・ヘッダだけ( str生曲ファイル名 );


			// スコアからタイトルを抽出し、GUIツリーに追加。

			var node = new TreeNode( score.Header.str曲名 );
			parentNodes.Insert( n挿入位置, node );


			// 対応表にも追加。

			this.dicノードSong対応表.Add(
				node,
				new SongNode() {
					Title = score.Header.str曲名,
					Description = score.Header.str説明文,
					ScoreFile = str生曲ファイル名,
					childlen = new List<SongNode>(),
				} );
		}
		protected void t曲ファイルを追加する( string[] arr生曲ファイル名 )
		{
			// 挿入位置を取得。

			TreeNodeCollection parentNodes = null;
			int n挿入位置 = 0;
			this.t現在の選択曲から挿入すべき親ノード集合と位置を返す( out parentNodes, out n挿入位置 );


			// すべての選択ファイルについて、ツリーと対応表に追加する。

			this.treeView曲ツリー.BeginUpdate();

			foreach( string str生ファイル名 in arr生曲ファイル名 )
			{
				this.t曲ファイルを追加する( str生ファイル名, parentNodes, n挿入位置 );
				n挿入位置++;
			}

			this.treeView曲ツリー.EndUpdate();
		}
		protected void tツリーに再帰的にアイテムを追加する( TreeNodeCollection nodes, List<SongNode> songs )
		{
			foreach( var song in songs )
			{
				// ノードを生成。

				var str生ファイル名 = Global.Folder.tファイルパスをマクロ付きパスに逆展開する( song.ScoreFile );
				var imageIndex = ( song.e種別 == SongNode.E種別.BOX ) ? this.nImageIndexを返す( "BOX_Opened" ) : this.nImageIndexを返す( "Node" );
				var node = new TreeNode( song.Title ) {
					ImageIndex = imageIndex,
					SelectedImageIndex = imageIndex,
				};


				// ツリーと対応表にノードを登録。

				nodes.Add( node );
				this.dicノードSong対応表.Add( node, song );


				// ノードに対応する Song が BOX であれば、再帰する。

				if( song.e種別 == SongNode.E種別.BOX && song.childlen != null )
				{
					this.tツリーに再帰的にアイテムを追加する( node.Nodes, song.childlen );
					node.Expand();
				}
			}
		}
		protected void tノードと子ノードを再帰的にツリーと対応表から除去する( TreeNode node )
		{
			// 子ノードがあれば先に再帰的に除去する。

			if( node.Nodes != null && node.Nodes.Count > 0 )
			{
				foreach( TreeNode child in node.Nodes )
					this.tノードと子ノードを再帰的にツリーと対応表から除去する( child );
			}


			// ノード自身を除去する。

			if( this.dicノードSong対応表.ContainsKey( node ) )
				this.dicノードSong対応表.Remove( node );		// 対応表から削除

			var parentNodes = this.treeView曲ツリー.Nodes;
			if( node.Parent != null )
				parentNodes = node.Parent.Nodes;
			parentNodes.Remove( node );							// ツリーから削除
		}
		protected void t現在の選択曲から挿入すべき親ノード集合と位置を返す( out TreeNodeCollection parentNodes, out int n挿入位置 )
		{
			parentNodes = null;
			n挿入位置 = 0;

			if( this.treeView曲ツリー.SelectedNode == null )
			{
				// (A) 選択されてない場合 → 最後のSongListの末尾から挿入開始。

				parentNodes = this.treeView曲ツリー.Nodes[ this.treeView曲ツリー.Nodes.Count - 1 ].Nodes;
				n挿入位置 = parentNodes.Count;
			}

			else if( this.treeView曲ツリー.SelectedNode.Parent == null )
			{
				// (B) SongListノードが選択されている → そのSongListノードの末尾から挿入開始。

				parentNodes = this.treeView曲ツリー.SelectedNode.Nodes;
				n挿入位置 = parentNodes.Count;
			}

			else
			{
				// (C) 曲ノードが選択されている → その曲の次行から挿入開始。

				parentNodes = this.treeView曲ツリー.SelectedNode.Parent.Nodes;
				n挿入位置 = parentNodes.IndexOf( this.treeView曲ツリー.SelectedNode ) + 1;
			}
		}
		protected void tGUIツリーからSongツリーを再帰的に構築する( TreeNodeCollection nodes, List<SongNode> listSong )
		{
			foreach( TreeNode node in nodes )
			{
				// 自身をSongツリーに登録する。

				var song = this.dicノードSong対応表[ node ];
				listSong.Add( song );


				// BOX なら子Songを再帰的に登録する。

				if( song.e種別 == SongNode.E種別.BOX )
					this.tGUIツリーからSongツリーを再帰的に構築する( node.Nodes, song.childlen );
			}
		}

		// GUIイベント

		protected void treeView曲ツリー_AfterSelect( object sender, TreeViewEventArgs e )
		{
			this.tGUIのEnableを設定する();
		}
		protected void treeView曲ツリー_AfterExpand( object sender, TreeViewEventArgs e )
		{
			// ノードアイコンを Opened にする。

			if( this.bSongListノードである( e.Node ) )
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "SongList_Opened" );
			}
			else if( this.dicノードSong対応表[ e.Node ].e種別 == SongNode.E種別.BOX )
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "BOX_Opened" );
			}
			else
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "Node" );
			}
		}
		protected void treeView曲ツリー_AfterCollapse( object sender, TreeViewEventArgs e )
		{
			// ノードアイコンを Closed にする。

			if( this.bSongListノードである( e.Node ) )
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "SongList_Closed" );
			}
			else if( this.dicノードSong対応表[ e.Node ].e種別 == SongNode.E種別.BOX )
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "BOX_Closed" );
			}
			else
			{
				e.Node.ImageIndex =
					e.Node.SelectedImageIndex = this.nImageIndexを返す( "Node" );
			}
		}
		protected void treeView曲ツリー_MouseDoubleClick( object sender, MouseEventArgs e )
		{
			TreeNode node = this.treeView曲ツリー.SelectedNode;

			if( this.bSongListノードである( node ) )
				return;		// SongList では何もしない。

			var song = this.dicノードSong対応表[ node ];


			// Song編集ダイアログを表示する。

			var dialog = new CSong編集ウィンドウ();
			dialog.Owner = this;
			dialog.textBoxノード種別.Text = ( song.e種別 == SongNode.E種別.BOX ) ? "BOX" : "Song";
			dialog.textBox曲名.Text = song.Title;
			dialog.textBox説明文.Text = song.Description;
			dialog.textBoxファイルパス.Text = Global.Folder.tファイルパスをマクロ付きパスに逆展開する( song.ScoreFile );
			dialog.textBoxファイルパス.Enabled = false;

			var dr = dialog.ShowDialog( this );
			if( dr == DialogResult.Cancel )
				return;		// キャンセル


			// ダイアログの内容にあわせて Song の情報を更新する。

			song.Title = dialog.textBox曲名.Text;
			song.Description = dialog.textBox説明文.Text;


			// ノードの情報を更新する。

			node.Text = song.Title;


			// 再描画。

			this.Refresh();
		}
		protected void treeView曲ツリー_DragEnter( object sender, DragEventArgs e )
		{
			// 送られてくるデータの型から、受入判定結果を e.Effect に格納する。

			if( e.Data.GetDataPresent( DataFormats.FileDrop ) )
				e.Effect = DragDropEffects.Copy;					// ファイルはOK
			else
				e.Effect = DragDropEffects.None;					// その他はNG
		}
		protected void treeView曲ツリー_DragDrop( object sender, DragEventArgs e )
		{
			// フォーマットチェック。

			if( !e.Data.GetDataPresent( DataFormats.FileDrop ) )
				return;		// ファイル以外は無視。


			// ファイルのリストを取得。

			string[] files = (string[]) e.Data.GetData( DataFormats.FileDrop );


			// すべての選択ファイルについて、ツリーと対応表に追加する。

			this.t曲ファイルを追加する( files );
		}
		protected void buttonSongListファイルを新規作成_Click( object sender, EventArgs e )
		{
			SaveFileDialog dialog;

			#region [ 保存ダイアログでファイルパスを取得。 ]
			//-----------------
			bool bTopMost控え = this.TopMost;
			this.TopMost = false;

			while( true )	// 正しいファイルパスを得るまで
			{
				dialog = new SaveFileDialog() {
					Title = "SongListファイルの新規作成",
					Filter = "SongList files (*.xml)|*.xml|All files(*.*)|*.*",
					FilterIndex = 1,
					InitialDirectory = Global.Folder.strユーザ個別フォルダ,
				};

				var dr = dialog.ShowDialog( Global.App.Window );	// ダイアログの表示、終了。
				this.Refresh();					// フォームを再描画してダイアログを完全に消す。

				if( dr != DialogResult.OK || string.IsNullOrEmpty( dialog.FileName ) )
					return;


				// パスをチェック。

				if( !dialog.FileName.Contains( Global.Folder.strユーザ個別フォルダ ) )
				{
					MessageBox.Show( "ユーザ個別フォルダの外側にはファイルを作成できません。", "警告", MessageBoxButtons.OK );
					continue;
				}
				break;
			}

			this.TopMost = bTopMost控え;
			//-----------------
			#endregion
			#region [ 既に存在しているファイルなら削除する。削除に失敗したらそこまで。]
			//-----------------
			if( File.Exists( dialog.FileName ) )
			{
				try
				{
					File.Delete( dialog.FileName );
				}
				catch( Exception ex )
				{
					C共通.t例外の詳細をログに出力する( ex );
					return;
				}
			}
			//-----------------
			#endregion


			// 空の SongList を作成し、保存する。

			var songList = new SongList();
			songList.t保存する( dialog.FileName );


			// SongList をツリーに追加する。

			this.tSongListファイルを追加する( dialog.FileName );
		}
		protected void buttonSongListファイルを追加_Click( object sender, EventArgs e )
		{
			#region [ ファイルを選択。複数可。]
			//-----------------
			bool bTopMost控え = this.TopMost;
			this.TopMost = false;

			var dialog = new OpenFileDialog() {
				Title = "SongListファイルの選択",
				Filter = "SongList files (*.xml)|*.xml|All files(*.*)|*.*",
				FilterIndex = 1,
				InitialDirectory = this.str最後に開いたフォルダ,
				Multiselect = true,
			};

			var dr = dialog.ShowDialog( Global.App.Window );	// ダイアログの表示、終了。
			
			this.Refresh();					// フォームを再描画してダイアログを完全に消す。
			this.TopMost = bTopMost控え;

			if( dr != DialogResult.OK || dialog.FileNames.Length == 0 )
				return;

			this.str最後に開いたフォルダ = Path.GetDirectoryName( Path.GetFullPath( dialog.FileNames[ 0 ] ) );
			//-----------------
			#endregion

			// すべての選択ファイルについて、内容をツリーに追加する。

			foreach( string str生SongListファイル名 in dialog.FileNames )
				this.tSongListファイルを追加する( str生SongListファイル名 );
		}
		protected void button曲を追加_Click( object sender, EventArgs e )
		{
			#region [ ファイルを選択。複数可。]
			//-----------------
			bool bTopMost控え = this.TopMost;
			this.TopMost = false;

			var dialog = new OpenFileDialog() {
				Title = "曲の選択",
				Filter = "SSTF files (*.sstf)|*.sstf",
				FilterIndex = 1,
				InitialDirectory = this.str最後に開いたフォルダ,
				RestoreDirectory = false,
				Multiselect = true,
			};

			var dr = dialog.ShowDialog( Global.App.Window );	// ダイアログの表示、終了。

			this.Refresh();					// フォームを再描画してダイアログを完全に消す。
			this.TopMost = bTopMost控え;

			if( dr != DialogResult.OK || dialog.FileNames.Length == 0 )
				return;

			this.str最後に開いたフォルダ = Path.GetDirectoryName( Path.GetFullPath( dialog.FileNames[ 0 ] ) );
			//-----------------
			#endregion

			this.t曲ファイルを追加する( dialog.FileNames );
		}
		protected void buttonフォルダ内指定して曲を追加_Click( object sender, EventArgs e )
		{
			#region [ フォルダを選択する。]
			//-----------------
			bool bTopMost控え = this.TopMost;
			this.TopMost = false;

			var dialog = new FolderBrowserDialog() {
				Description = "曲を検索するフォルダを選択して下さい。",
				RootFolder = Environment.SpecialFolder.MyComputer,
				SelectedPath = this.str最後に開いたフォルダ,
				ShowNewFolderButton = false,
			};

			var dr = dialog.ShowDialog( Global.App.Window );	// ダイアログの表示、終了。
			
			this.Refresh();					// フォームを再描画してダイアログを完全に消す。
			this.TopMost = bTopMost控え;

			if( dr != DialogResult.OK || string.IsNullOrEmpty( dialog.SelectedPath ) )
				return;

			this.str最後に開いたフォルダ = dialog.SelectedPath;
			//-----------------
			#endregion


			// 選択されたフォルダとその子フォルダから曲を検索する。

			string[] files = Directory.GetFiles( dialog.SelectedPath, "*.sstf", SearchOption.AllDirectories );


			// すべての選択ファイルについて、ツリーと対応表に追加する。

			this.t曲ファイルを追加する( files );
		}
		protected void buttonSongList上へ_Click( object sender, EventArgs e )
		{
			TreeNode node = this.treeView曲ツリー.SelectedNode;
			TreeNodeCollection parentNodes = ( node.Parent == null ) ? this.treeView曲ツリー.Nodes : node.Parent.Nodes;

			int n移動元番号 = parentNodes.IndexOf( node );
			int n移動先番号 = n移動元番号 - 1;

			if( n移動先番号 < 0 )
				return;


			// ツリー内で移動

			TreeNode tmpNode = parentNodes[ n移動元番号 ];
			parentNodes.RemoveAt( n移動元番号 );
			parentNodes.Insert( n移動先番号, tmpNode );

			this.treeView曲ツリー.SelectedNode = parentNodes[ n移動先番号 ];
			this.treeView曲ツリー.Select();
		}
		protected void buttonSongList下へ_Click( object sender, EventArgs e )
		{
			TreeNode node = this.treeView曲ツリー.SelectedNode;
			TreeNodeCollection parentNodes = ( node.Parent == null ) ? this.treeView曲ツリー.Nodes : node.Parent.Nodes;

			int n移動元番号 = parentNodes.IndexOf( node );
			int n移動先番号 = n移動元番号 + 1;

			if( n移動先番号 >= parentNodes.Count )
				return;


			// GUIツリー内での移動

			TreeNode tmpNode = parentNodes[ n移動元番号 ];
			parentNodes.RemoveAt( n移動元番号 );
			parentNodes.Insert( n移動先番号, tmpNode );

			this.treeView曲ツリー.SelectedNode = parentNodes[ n移動先番号 ];
			this.treeView曲ツリー.Select();
		}
		protected void button選択項目をリストから除去_Click( object sender, EventArgs e )
		{
			var node削除対象 = this.treeView曲ツリー.SelectedNode;
			if( node削除対象 == null )
				return;

			this.tノードと子ノードを再帰的にツリーと対応表から除去する( node削除対象 );
			this.tGUIのEnableを設定する();
		}
		protected void buttonBOXを作成_Click( object sender, EventArgs e )
		{
			#region [ Song編集ダイアログを表示し、情報を得る。]
			//-----------------
			var dialog = new CSong編集ウィンドウ();
			dialog.Owner = this;
			dialog.textBoxノード種別.Text = "BOX";
			dialog.textBoxファイルパス.Enabled = false;

			var dr = dialog.ShowDialog();
			if( dr == DialogResult.Cancel )
				return;		// キャンセル
			//-----------------
			#endregion

			#region [ BOX 用の Song インスタンスを作成。]
			//-----------------
			var song = new SongNode() {
				Title = dialog.textBox曲名.Text,
				Description = dialog.textBox説明文.Text,
				ScoreFile = "",
				e種別 = SongNode.E種別.BOX,
				childlen = new List<SongNode>(),	// .xml から読み込んだときのデフォルト値は、null ではなく空Listである。ここではそれに合わせる。
			};
			//-----------------
			#endregion

			#region [ BOX をツリーに追加。]
			//-----------------

			// 挿入位置を取得。

			TreeNodeCollection parentNodes = null;
			int n挿入位置 = 0;
			this.t現在の選択曲から挿入すべき親ノード集合と位置を返す( out parentNodes, out n挿入位置 );


			// BOXをツリーに追加。

			this.treeView曲ツリー.BeginUpdate();

			var node = new TreeNode( song.Title ) {
				ImageIndex = this.nImageIndexを返す( "BOX_Opened" ),
				SelectedImageIndex = this.nImageIndexを返す( "BOX_Opened" ),
			};
			parentNodes.Insert( n挿入位置, node );

			this.treeView曲ツリー.EndUpdate();

			node.Expand();
			this.treeView曲ツリー.SelectedNode = node;
			this.treeView曲ツリー.Select();
			//-----------------
			#endregion
			#region [ BOX を対応表に追加する。]
			//-----------------
			this.dicノードSong対応表.Add( node, song );
			//-----------------
			#endregion
		}
		protected void button選択項目をBOXに入れる_Click( object sender, EventArgs e )
		{
			TreeNode node = this.treeView曲ツリー.SelectedNode;
			TreeNodeCollection parentNodes = ( node.Parent == null ) ? this.treeView曲ツリー.Nodes : node.Parent.Nodes;
			int nodeIndex = parentNodes.IndexOf( node );
			int boxIndex = nodeIndex - 1;

			if( boxIndex < 0 || this.bSongListノードである( parentNodes[ boxIndex ] ) || this.dicノードSong対応表[ parentNodes[ boxIndex ] ].e種別 != SongNode.E種別.BOX )	// 念のため確認。
				return;


			// ツリー内で移動

			parentNodes.RemoveAt( nodeIndex );
			parentNodes[ boxIndex ].Nodes.Add( node );

			this.treeView曲ツリー.SelectedNode = node;
			this.treeView曲ツリー.Select();
		}
		protected void button選択項目をBOXから出す_Click( object sender, EventArgs e )
		{
			TreeNode node = this.treeView曲ツリー.SelectedNode;
			TreeNode boxNode = node.Parent;
			TreeNodeCollection boxNodes = boxNode.Nodes;
			TreeNodeCollection parentNodes = boxNode.Parent.Nodes;
			int boxIndex = parentNodes.IndexOf( boxNode );


			// ツリー内で移動

			boxNodes.Remove( node );
			parentNodes.Insert( boxIndex + 1, node );

			this.treeView曲ツリー.SelectedNode = node;
			this.treeView曲ツリー.Select();
		}
		//-----------------
		#endregion
	}
}
