﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;

namespace StrokeStyleT
{
	public partial class Cユーザ登録 : Form
	{
		public Cユーザ登録()
		{
			InitializeComponent();
		}

		private void textBoxユーザ名_TextChanged( object sender, EventArgs e )
		{
			this.button登録.Enabled = !string.IsNullOrEmpty( this.textBoxユーザ名.Text );
		}
		private void button登録_Click( object sender, EventArgs ev )
		{
			string str新登録ユーザ名 = this.textBoxユーザ名.Text;

			#region [ 既に存在しているユーザの場合はやり直し。]
			//-----------------
			foreach( var name in Global.Users.User )
			{
				if( name.Equals( str新登録ユーザ名, StringComparison.OrdinalIgnoreCase ) )
				{
					MessageBox.Show( "すでに存在しているユーザです。\n別の名前を指定して下さい。", "警告", MessageBoxButtons.OK );
					return;
				}
			}
			//-----------------
			#endregion
			#region [ 不適切な文字列ならやり直し。]
			//-----------------
			if( str新登録ユーザ名.Contains( @"\" ) ||	// '\' はダメ
				str新登録ユーザ名.Contains( @"/" ) )	// '/' もダメ
			{
				MessageBox.Show( @"'\'または'/'は使用できません。", "警告", MessageBoxButtons.OK );
				return;
			}

			try
			{
				Global.Folder.tパスを絶対パスに変換しパスとしての正当性を確認する( str新登録ユーザ名, Global.Folder.strユーザ共通フォルダ );
			}
			catch( PathTooLongException )
			{
				MessageBox.Show( "ユーザ名が長すぎます。", "警告", MessageBoxButtons.OK );
				return;
			}
			catch
			{
				MessageBox.Show( "利用できない文字が含まれています。", "警告", MessageBoxButtons.OK );
				return;
			}
			//-----------------
			#endregion

			try
			{
				Global.Users.tユーザを新規追加しXMLファイルを保存する( str新登録ユーザ名, Global.Folder.strUsersXMLの絶対パス );
			}
			catch( Exception e )
			{
				MessageBox.Show( "ユーザの新規登録に失敗しました。\n--------\n" + e.ToString(), "StrokeStyle<T>エラー", MessageBoxButtons.OK, MessageBoxIcon.Error );
				// そのまま終了する。
			}

			// ダイアログ終了。

			this.DialogResult = DialogResult.OK;
			this.Close();
		}
	}
}
